(function() {
	// データベース対象
	var db = null;

	/*
	 * データベース開く (v1)
	 */
	openDbV1 = function() {
		if (db) {
			alert('データベースは既に開かれています');
			return;
		}
		//データベース名
		var dbName = document.getElementById("dbName").value;
		applican.openDatabase(dbName, openDbSuccess, openDbError);
	}

	/*
	 * データベース開く (v2)
	 */
	openDbV2 = function() {
		if (db) {
			alert('データベースは既に開かれています');
			return;
		}
		//データベース名
		var dbName = document.getElementById("dbName").value;
		applican.database.open(dbName, openDbSuccess, openDbError);
	}

	/*
	 * データベース開く成功時のcallback処理
	 */
	function openDbSuccess(dbObj) {
		db = dbObj;
		var dump = "データベースを開きました。\n";
		dump    += "データベース名：";
		dump    += db.name + "\n";
		alert(dump);
	}

	/*
	 * データベース開く失敗時のcallback処理
	 */
	function openDbError(error) {
		var dump = "データベースを開けません。\n";
		dump    += "message：";
		dump    += error.message + "\n";
		alert(dump);
	}

	function closeDb() {
		if (!db) {
			alert('データベースは既に閉じています');
			return;
		}
		db.close(closeDbSuccess, closeDbError);
	}

	function closeDbSuccess() {
		var dump = "データベースを閉じました\n";
		dump    += "データベース名：";
		dump    += db.name + "\n";
		alert(dump);
		db = null;
	}

	function closeDbError(error) {
		var dump = "データベースを閉じられません。\n";
		dump    += "message：";
		dump    += error.message + "\n";
		alert(dump)
	}

	function closeAllDb() {
		if (!db) {
			alert('データベースは既に閉じています');
			return;
		}
		applican.database.closeAllDatabases(closeAllDbSuccess, closeAllDbError);
	}

	function closeAllDbSuccess() {
		var dump = "データベースを全て閉じました\n";
		alert(dump);
		db = null;
	}

	function closeAllDbError(error) {
		var dump = "データベースを閉じられません。\n";
		dump    += "message：";
		dump    += error.message + "\n";
		alert(dump)
	}

	/*
	 * テーブル作成
	 */
	createTable = function() {
		if(db === null) {
			alert("データベースを開いてください。");
			return;
		}
		var sql = document.getElementById("createTableSQL").value;
		//SQLを実行
		db.exec(sql, createTableSuccess, createTableError);
	}

	/*
	 * テーブル作成成功時のcallback処理
	 */
	function createTableSuccess(result) {
		var dump = "テーブルを作成しました。\n";
		alert(dump);
	}

	/*
	 * テーブル作成失敗時のcallback処理
	 */
	function createTableError(error) {
		var dump = "テーブルの作成に失敗しました。\n";
		dump += error.message + "\n";
		alert(dump);
	}

	/*
	 * テーブル削除
	 */
	dropTable = function() {
		if(db === null) {
			alert("データベースを開いてください。");
			return;
		}
		var sql = document.getElementById("dropTableSQL").value;
		//SQLを実行
		db.exec(sql, dropTableSuccess, dropTableError);
	}

	/*
	 * テーブル削除成功時のcallback処理
	 */
	function dropTableSuccess(result) {
		var dump = "テーブルを削除しました。\n";
		alert(dump);
	}

	/*
	 * テーブル削除失敗時のcallback処理
	 */
	function dropTableError(error) {
		var dump = "テーブルの削除に失敗しました。\n";
		dump += error.message + "\n";
		alert(dump);
	}

	/*
	 * データ挿入
	 */
	insertData = function() {
		if(db === null) {
			alert("データベースを開いてください。");
			return;
		}
		var sql = document.getElementById("insertDataSQL").value;
		//SQLを実行
		db.exec(sql, insertDataSuccess, insertDataError);
	}

	/*
	 * データ挿入成功時のcallback処理
	 * 引数の構成：
	 * 	insertId					データベースに挿入された行の行番号
	 * 	rowsAffected : Number		データ操作件数（INSERT,UPDATE,DELETE時）
	 * 	rows         : DatabaseResultRow[]	データ検索結果（SELECT時）
	 */
	function insertDataSuccess(result) {
		var dump = "データを挿入しました。\n";
		dump += "insertId:" + result.insertId + "\n";
		alert(dump);
	}

	/*
	 * データ挿入失敗時のcallback処理
	 */
	function insertDataError(error) {
		var dump = "データの挿入に失敗しました。\n";
		dump += error.message + "\n";
		alert(dump);
	}

	/*
	 * データ削除
	 */
	deleteData = function() {
		if(db === null) {
			alert("データベースを開いてください。");
			return;
		}
		var sql = document.getElementById("deleteDataSQL").value;
		//SQLを実行
		db.exec(sql, deleteDataSuccess, deleteDataError);
	}

	/*
	 * データ削除成功時のcallback処理
	 * 引数の構成：
	 * 	insertId					データベースに挿入された行の行番号
	 * 	rowsAffected : Number		データ操作件数（INSERT,UPDATE,DELETE時）
	 * 	rows         : DatabaseResultRow[]	データ検索結果（SELECT時）
	 */
	function deleteDataSuccess(result) {
		var dump = "データを削除しました。\n";
		dump += "削除行数:" + result.rowsAffected + "\n";
		alert(dump);
	}

	/*
	 * データ削除失敗時のcallback処理
	 */
	function deleteDataError(error) {
		var dump = "データの削除に失敗しました。\n";
		dump += error.message + "\n";
		alert(dump);
	}

	/*
	 * 一括処理
	 */
	execTransaction = function() {
		if(db === null) {
			alert("データベースを開いてください。");
			return;
		}

		/*
		 * SQL配列の例
		 * var sqls = [
		 * 	"DROP TABLE IF EXISTS DEMO",
		 * 	"CREATE TABLE IF NOT EXISTS DEMO (id unique, data, data2)",
		 * 	"INSERT INTO DEMO (id, data, data2) VALUES (1, 'First row', NULL)",
		 * 	"INSERT INTO DEMO (id, data, data2) VALUES (2.1, 'Second row', 'test')"
		 * 	];
		 */
		var sqls = document.getElementById("execTransactionSQL").value.split("\n");

		//更新系の処理を一括で行うための機能です。
		//トランザクション処理を行うため、途中で失敗した場合はロールバックされます。
		db.execTransaction(sqls, execTransactionSuccess, execTransactionError);
	}

	/*
	 * 一括処理実行成功時のcallback処理
	 * 引数の構成：
	 * 	insertId					データベースに挿入された行の行番号
	 * 	rowsAffected : Number		データ操作件数（INSERT,UPDATE,DELETE時）
	 * 	rows         : DatabaseResultRow[]	データ検索結果（SELECT時）
	 */
	function execTransactionSuccess(result) {
		var dump = "SQL一括実行しました。\n";
		dump += "rowsAffected:" + result.rowsAffected + "\n";
		dump += "insertId:" + result.insertId + "\n";
		alert(dump);
	}

	/*
	 * 一括処理実行失敗時のcallback処理
	 */
	function execTransactionError(error) {
		var dump = "SQL一括実行に失敗しました。\n";
		dump += error.message + "\n";
		alert(dump);
	}

	/*
	 * データ検索
	 */
	searchData = function() {
		if(db === null) {
			alert("データベースを開いてください。");
			return;
		}
		var sql = document.getElementById("searchDataSQL").value;
		db.query(sql, searchDataSuccess, searchDataError);
	}

	/*
	 * データ検索成功時のcallback処理
	 * 引数の構成：
	 * 	insertId					データベースに挿入された行の行番号
	 * 	rowsAffected : Number		データ操作件数（INSERT,UPDATE,DELETE時）
	 * 	rows         : DatabaseResultRow[]	データ検索結果（SELECT時）
	 */
	function searchDataSuccess(result) {
		var dump = "データ検索成功しました。\n";
		var cnt = result.rows.length;
		dump += "行数:" + cnt + "\n";
		for(var i = 0; i < cnt; i++) {
			dump += "id:" + result.rows[i].id + ", data:" + result.rows[i].data + ", data2:" + result.rows[i].data2 + "\n";
		}
		alert(dump);
	}

	/*
	 * データ検索失敗時のcallback処理
	 */
	function searchDataError(error) {
		var dump = "データ検索に失敗しました。\n";
		dump += error.message + "\n";
		alert(dump);
	}

	/********************* イベント登録 *********************/
	document.addEventListener("deviceready", function() {
		// 「データベースを開く」ボタン押下処理 (v1)
		document.getElementById("openDatabaseV1Btn").addEventListener("touchend", openDbV1, false);
		// 「データベースを開く」ボタン押下処理 (v2)
		document.getElementById("openDatabaseV2Btn").addEventListener("touchend", openDbV2, false);
		// 「データベースを閉じる」ボタン押下処理
		document.getElementById("cloaseDatabaseBtn").addEventListener("touchend", closeDb, false);
		// 「データベースを全て閉じる」ボタン押下処理
		document.getElementById("closeAllDatabasesBtn").addEventListener("touchend", closeAllDb, false);
		// 「テーブル作成」ボタン押下処理
		document.getElementById("createTableBtn").addEventListener("touchend", createTable, false);
		// 「テーブル削除」ボタン押下処理
		document.getElementById("dropTableBtn").addEventListener("touchend", dropTable, false);
		// 「データ書き込み」ボタン押下処理
		document.getElementById("insertDataBtn").addEventListener("touchend", insertData, false);
		// 「データ削除」ボタン押下処理
		document.getElementById("deleteDataBtn").addEventListener("touchend", deleteData, false);
		// 「トランザクション処理」ボタン押下処理
		document.getElementById("execTransactionBtn").addEventListener("touchend", execTransaction, false);
		// 「データ検索」ボタン押下処理
		document.getElementById("searchDataBtn").addEventListener("touchend", searchData, false);
	}, false);
})();
